#include "bootldr.h"

void set_last_buttonpress(int junk)
{
}

int get_last_buttonpress(void)
{
    int retval = 0;
    static int need_zero;
    /*
     * KEY_AP1, Mail, PXA GPIO-94
     * KEY_AP2, Calendar, ASIC3-GPIOD-1
     * KEY_AP3, Contacts, PXA GPIO-99
     * KEY_AP4, Launch, ASIC3-GPIOD-3
     * AUD_RECORD, ASIC3-GPIOD-6
     * KEY_ON, PXA GPIO-0
     */
    if((*((unsigned int *)0x40e00000) & 1) == 0) {
        retval = 1; /* Power */
    }
    if((*((unsigned int *)0x40e00008) & 0x40000000)) {
        retval = 2; /* Mail */
    }
    if((*((unsigned int *)0x40e00100) & 0x00000008)) {
        retval = 3; /* Contacts */
    }
    if((*((unsigned int *)0x0c000198) & 0x00000002) == 0) {
        retval = 4; /* Calendar */
    }
    if((*((unsigned int *)0x0c000198) & 0x00000008) == 0) {
        retval = 5; /* Launch */
    }
    if((*((unsigned int *)0x0c000198) & 0x00000040) == 0) {
        retval = 6; /* Record */
    }
    if(need_zero) {
        if(retval == 0) {
            need_zero = 0;
        } else {
            retval = 0;
        }
    } else {
        need_zero = retval;
    }
    return retval;
}

void set_exec_buttons_automatically(int junk)
{
}

void msleep(unsigned int milliseconds)
{
    /*
     * Set resolution of counter to 1 millisecond (OMCR5, OSMR5)
     */
    *((volatile unsigned int*)0x40a000c4) = 0x82;
    *((volatile unsigned int*)0x40a00084) = milliseconds;

    /* Write to OSCR5 */
    *((volatile unsigned int*)0x40a00044) = 0;
    while(*((volatile unsigned int*)0x40a00044) < milliseconds)
        ;

}

void
initialize_asic3(void)
{
    /* I'm just hard-coding these for now */
    volatile unsigned short *asic3;

    asic3 = (unsigned short *)0x0c000000;

#if 1
    *((unsigned long *)0x40e0002c) = 0x80;
    msleep(100);
    *((unsigned long *)0x40e00020) = 0x80;
    msleep(100);
#endif

    *(asic3 +   0xb) |= 1; /* Sleep Config Set bit 1 */
    *(asic3 +  0x4b) |= 1; /* Sleep Config Set bit 1 */
    *(asic3 +  0x8b) |= 1; /* Sleep Config Set bit 1 */
    *(asic3 +  0xcb) |= 1; /* Sleep Config Set bit 1 */

    msleep(500);

#if 0
    *(asic3 +  0xa) = 0xffff; /* Alt Function */
    *(asic3 + 0x4a) = 0xffff; /* Alt Function */
    *(asic3 + 0x8a) = 0xfff7; /* 0xfff1;*/ /* Alt Function HTC: fff7 */
    *(asic3 + 0xca) = 0x9800; /* Alt Function */

    *(asic3 +  0x2) = 0x0000; /* Output */
    *(asic3 + 0x42) = 0x0000; /* Output */
    *(asic3 + 0x82) = 0xff88; /* 0x0000; */ /* Output HTC: FF88 */
    *(asic3 + 0xc2) = 0xa000; /* Output HTC: a000*/

    *(asic3 +  0x1) = 0xffff; /* Direction Registers */
    *(asic3 + 0x41) = 0xffff; /* Direction Registers */
    *(asic3 + 0x81) = 0x6067; /* Direction Registers */
    *(asic3 + 0xc1) = 0x0000; /* Direction Registers */
#endif

    /* GPIO A */
    *(asic3 +  0x0) = 0xffff; /* Turn off interrupts */
    *(asic3 +  0x2) = 0x0000; /* Output */
    *(asic3 +  0x3) = 0x0000; /* Trigger Type */
    *(asic3 +  0x4) = 0x0000; /* Edge Trigger */
    *(asic3 +  0x5) = 0x0000; /* Level Trigger */
    *(asic3 +  0x6) = 0xffff; /* Sleep Mask */
    *(asic3 +  0x7) = 0x0000; /* Sleep Out */
    *(asic3 +  0x8) = 0x0000; /* BattFault Out */
    *(asic3 +  0x9) = 0x0000; /* Interrupt status */
    *(asic3 +  0xa) = 0xffff; /* Alt Function */
#if 0
    *(asic3 +  0xb) = 0x000c; /* Sleep Config. Not sure why it's 0x000c */
#endif
    *(asic3 +  0x1) = 0xffff; /* Direction Registers */

    /* GPIO B */
    *(asic3 + 0x40) = 0xffff; /* Turn off interrupts */
    *(asic3 + 0x42) = 0x0000; /* Output */
    *(asic3 + 0x43) = 0x0000; /* Trigger Type */
    *(asic3 + 0x44) = 0x0000; /* Edge Trigger */
    *(asic3 + 0x45) = 0x0000; /* Level Trigger */
    *(asic3 + 0x46) = 0xffff; /* Sleep Mask */
    *(asic3 + 0x47) = 0x0000; /* Sleep Out */
    *(asic3 + 0x48) = 0x0000; /* BattFault Out */
    *(asic3 + 0x49) = 0x0000; /* Interrupt status */
    *(asic3 + 0x4a) = 0xffff; /* Alt Function */
#if 0
    *(asic3 + 0x4b) = 0x000c; /* Sleep Config. Not sure why it's 0x000c */
#endif
    *(asic3 + 0x41) = 0xffff; /* Direction Registers */

    /* GPIO C */
    *(asic3 + 0x80) = 0xffff; /* Turn off interrupts */
    *(asic3 + 0x82) = 0xff88; /* 0x0000; */ /* Output HTC: FF88 */
    *(asic3 + 0x83) = 0x0000; /* Trigger Type */
    *(asic3 + 0x84) = 0x0000; /* Edge Trigger */
    *(asic3 + 0x85) = 0x0000; /* Level Trigger */
    *(asic3 + 0x86) = 0xffff; /* Sleep Mask */
    *(asic3 + 0x87) = 0x0000; /* Sleep Out */
    *(asic3 + 0x88) = 0x0000; /* BattFault Out */
    *(asic3 + 0x89) = 0x0000; /* Interrupt status */
    *(asic3 + 0x8a) = 0xfff7; /* 0xfff1;*/ /* Alt Function HTC: fff7 */
#if 0
    *(asic3 + 0x8b) = 0x000c; /* Sleep Config. Not sure why it's 0x000c */ 
#endif
    *(asic3 + 0x81) = 0x6067; /* Direction Registers */

    /* GPIO D */
    *(asic3 + 0xc0) = 0xffff; /* Turn off interrupts */
    *(asic3 + 0xc2) = 0xa000; /* Output HTC: a000*/
    *(asic3 + 0xc3) = 0x0000; /* Trigger Type */
    *(asic3 + 0xc4) = 0x0000; /* Edge Trigger */
    *(asic3 + 0xc5) = 0x0000; /* Level Trigger */
    *(asic3 + 0xc6) = 0x9800; /* Sleep Mask */
    *(asic3 + 0xc7) = 0x0000; /* Sleep Out */
    *(asic3 + 0xc8) = 0x0000; /* BattFault Out */
    *(asic3 + 0xc9) = 0x0000; /* Interrupt status */
    *(asic3 + 0xca) = 0x9800; /* Alt Function */
#if 0
    *(asic3 + 0xcb) = 0x000c; /* Sleep Config. Not sure why it's 0x000c */
#endif
    *(asic3 + 0xc1) = 0x0000; /* Direction Registers */

#if 0
    /* SD Clock */
    *(asic3 + 0x280) = 0x63cb;
    *(asic3 + 0x281) = 0x0005;
    /* SD Mem Enable */
    *(asic3 + 0x440) |= (1 << 14);
    *(asic3 + 0x380) = 0x10; /* Wake up */
#endif

#if 0
    /* Interrupt Control */
    *(asic3 + 0x2c0) = 0x0000; /* Mask.  Not sure if 1 is off or on */
    *(asic3 + 0x2c2) = 0x000e; /* Interrupt Timer prescale */
    *(asic3 + 0x2c3) = 0x8000; /* Interrupt Timer set */

    /* SD Control */
    /* Not going to touch these */
    /* *(asic3 + 0x300) = 0x8000;  *//* Interrupt Timer set */

    /* Hardware Protect. Not sure what this is. */
    /* *(asic3 + 0x400) = ;  */
#endif

#if 0
    /* EXT CF */
    *(asic3 + 0x440) = 0x5490; /* That's what wince has */
    /*
     * 5490 = 0101 0100 1001 0000
    0
      0 smod0      -- slot number of mode0
      0 smod1      -- slot number of mode1
      0 smod2      -- slot number of mode 2
      0 unused

    9
      1 onewire_en
      0 onewire_bus_selec

      0 cf0_sleep_state   (2 bits)
      1

    4
      0 cf1_sleep_state   (2 bits)
      0

      1 cf0_pwait_n control
      0 cf1_pwait_n control

    5
      1 cf0_buffer_en
      0 cf1_buffer_en
      1 sd_memory_interface_enable
      0 cf_sleep_mode
    */


    /* My own concoction */
    *(asic3 + 0x442) = 0xffff;
    msleep(100);
    *(asic3 + 0x442) = 0x0000;
#endif
}

void set_vppen(void)
{
    /* Set GPIO 91 */
    /* putstr("vppen\r\n"); */
    *((unsigned int *) 0x40e00020) = 0x08000000;
}

void clr_vppen(void)
{
    /* Clear GPIO 91 */
    /* putstr("vppdi\r\n"); */
    *((unsigned int *) 0x40e0002c) = 0x08000000;
}

#define ONEWIRE_Tslot                   60
#define ONEWIRE_Trec                    1
#define ONEWIRE_Tlow0                   60
#define ONEWIRE_Tlow1                   1
#define ONEWIRE_Trdv                    8               /* max 15 */
#define ONEWIRE_Trsth                   480
#define ONEWIRE_Trstl                   480
#define ONEWIRE_Tpdh                    15
#define ONEWIRE_Tpdl                    60
#define ONEWIRE_Tswl                    1               /* min 0.2, max 120 */
#define ONEWIRE_Tswoff                  0               /* max 1 */
#define ONEWIRE_Tswon                   0               /* max 1 */

#define ONEWIRE_DRIVE(v)        ((*(volatile unsigned int*)0x40000000) = (v))
#define ONEWIRE_NODRIVE()       ((*(volatile unsigned int*)0x40000000) = (0))
#define ONEWIRE_READ()          (*(volatile unsigned int*)0x40000000)
#define udelay(x)               do {} while(0)

int
onewire_init(void)
{
    int data;

    ONEWIRE_DRIVE(0);
    udelay(ONEWIRE_Trstl);
    ONEWIRE_NODRIVE();
    udelay(ONEWIRE_Trec + ONEWIRE_Tpdh + ONEWIRE_Tpdl / 2);
    data = ONEWIRE_READ();
    if(data == 0) {
        return 1;
    }
    return 0;
}

void
onewire_write_slot(unsigned char d)
{
    ONEWIRE_DRIVE(0);
    if(!d) {
        /* Drive a zero for a while */
        udelay(ONEWIRE_Tlow0);
        ONEWIRE_NODRIVE();
    } else {
        udelay(ONEWIRE_Tlow1);
        ONEWIRE_NODRIVE();
        udelay(ONEWIRE_Tslot - ONEWIRE_Tlow1);
    }
    udelay(ONEWIRE_Trec);
}

int
onewire_read_slot(void)
{
    int retval;
    ONEWIRE_DRIVE(0);
    udelay(1);
    ONEWIRE_NODRIVE();
    udelay(ONEWIRE_Trdv);
    retval = ONEWIRE_READ();
    udelay(ONEWIRE_Tslot - ONEWIRE_Trdv - 1 + ONEWIRE_Trec);
    return retval;
}

void
onewire_write_byte(unsigned char d)
{
    int i;
    for(i = 0; i < 8; i++) {
        onewire_write_slot((d >> i) & 1);
    }
}

unsigned char
onewire_read_byte(void)
{
    unsigned char retval;
    int i;
    for(retval = 0, i = 0; i < 8; i++) {
        retval |= onewire_read_slot() << i;
    }
    return retval;
}

int
onewire_read_net_address(unsigned char addr[8])
{
    if(!onewire_init()) {
        return 0;
    }
    onewire_write_byte(0x33); /* Read Net Address */

    addr[0] = onewire_read_byte();
    addr[1] = onewire_read_byte();
    addr[2] = onewire_read_byte();
    addr[3] = onewire_read_byte();
    addr[4] = onewire_read_byte();
    addr[5] = onewire_read_byte();
    addr[6] = onewire_read_byte();
    addr[7] = onewire_read_byte();
    return 1;
}

int
onewire_read_data(unsigned char addr, unsigned char *data)
{
    if(!onewire_init()) {
        return 0;
    }

    onewire_write_byte(0xcc); /* Skip Net Address */
    onewire_write_byte(0x69); /* Read Data */
    onewire_write_byte(addr); /* Address */

    *data = onewire_read_byte();
    return 1;
}

/*
 * This function (onewire_read_next()) is to be used after
 * onewire_read_data().  The device continues to read data and automatically
 * increments the address for us.
 */
int
onewire_read_next(unsigned char *data)
{
    *data = onewire_read_byte();
    return 1;
}
